/* dfstream.h {\documentstyle{jsrc2latex}\rhead{\sl dfstream.h\quad\thepage}
   \font\tenrm=cmtt10}
{\ \begin{verbatim}
$RCSfile$  $Revision$ 
$Date$  by KyotoHydro
\end{verbatim}}
{\ {\setlength{\parskip}{4pt}% latex-mode

}% end of latex-mode }

Define dfstream class for data files

    If you use dfstream class, you can enter comment strings into data
    files.  The strings from character # to the end of the line are
    regarded as comments and are ignored when being read. If character #
    appears at the first column, then the line itself is ignored.  The
    charcters # within the strings surrownded by "..." or '...' are not
    regarded the starts of comment strings.
*/
/*	For example, assume file "foo.data" is as follows

	1 2 # the strings after # are comments
	# this line will be ignored
	3

	Then the codes

	int ia, ib, ic;
	dfstream fi("foo.data");
    fi >> ia >> ib >> ic;

	will set ia, ib, and ic to be 1, 2, and 3, respectively.
	
*/

#include <fstream>
#include <unistd.h>

using namespace std;   // added on Oct. 4, 2007

class dfstream : public ifstream {

  public:

	dfstream() 
	: ifstream() { openFlag = 0; }

	dfstream(const char* name)
	: ifstream() {
		openFlag = 0;
		open(name);
	}

	void open(const char* name);

	~dfstream();

  protected:

	char dfname[128];
	int openFlag;

};

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision$

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */

