/* slist.h {\documentstyle{jsrc2latex}\rhead{\sl slist.h\quad\thepage}
   \font\tenrm=cmtt10}
{\ \begin{verbatim}
$RCSfile: slist.h,v $  $Revision: 1.1 $ 
$Date: 1996/09/05 10:43:00 $  by KyotoHydro
\end{verbatim}}
{\ {\setlength{\parskip}{4pt}% latex-mode

}% end of latex-mode }
ΥץϡScott Robert Ladd ˤ C++ Templates and Tools 
˷ǺܤƤץ򸵤ˤƤޤ

Υץϡ㳰(try, throw, catch ʤɤȤ)Υɤ
Ǥޤ̾Υ顼(顼å񤤤ơexit ) 
֤Ƥޤ

ޤ饹 SListDynamic ˥дؿ Remove ɲäޤRemove ϡ
 Work ؤƤܤꥹȤޤ
*/

//=============================================================
// Singly-Linked Lists      slist.h         v1.00
//      Defines templates for classes of singly-linked lists
//      Copyright 1995 Scott Robert Ladd
//=============================================================

#ifndef SLIST_H
#define SLIST_H

#include <limits.h>
#include <assert.h>
#include <stddef.h>
#include "boolean.h"

//---------------------------
// dynamic singly-linked list
//---------------------------

template <class T>
    class SListDynamic
        {
        public:
            // constructors
            SListDynamic
                (
                Boolean circ = NO
                );

            // copy constructor
            SListDynamic
                (
                const SListDynamic<T> & slst,
                Boolean shallow = NO
                );

            // construct from array
            SListDynamic
                (
                const T * array,
                size_t no
                );

            // destructor
            ~SListDynamic();

            // assignment operator (deep copy)
            void operator =
                (
                const SListDynamic<T> & slst
                );

            // conversion to array operator
            operator T * ();

            // append new items
            void Append
                (
                const T & item
                );

            void Append
                (
                const T * array,
                size_t no
                );

            void Append
                (
                const SListDynamic<T> & slst
                );

			// remove current item
	        // ιܤդɲäޤ
	        void Remove();

            // remove all items from the list
            void Erase();

            // get current item
            T Get();

            // TRUE if current item is last item
            Boolean AtTail();

            // set current item to head of list
            void ToHead();

            // move to next item in list
            Boolean ToNext();

            // interrogate list
            size_t  GetCount();
            Boolean IsShallow();
            Boolean IsCircular();

        protected:
            // type defining a node in the list
            struct Node
                {
                T Data;
                Node * Next;
                };

            size_t Count; // # of items in list
            Node * Head;  // first item
            Node * Tail;  // last item
            Node * Work;  // current item

            Boolean Shallow;  // Is this a shallow copy?
            Boolean Circular; // is this a circular list?

            // internal utility functions
            void DeepCopy
                (
                const SListDynamic<T> & slst
                );

            void ShallowCopy
                (
                const SListDynamic<T> & slst
                );

            void SetNull();
        };

//--------------------------
// static singly-linked list
//--------------------------

template <class T, size_t Limit>
    class SList
        {
        public:
            // constructors
            SList
                (
                Boolean circ = NO
                );

            // copy constructor
            SList
                (
                const SList<T,Limit> & slst
                );

            // construct from array
            SList
                (
                const T * array,
                size_t no
                );

            // destructor
            ~SList();

            // assignment operator (deep copy)
            void operator =
                (
                const SList<T,Limit> & slst
                );

            // conversion to array operator
            operator T * ();

            // append new items
            void Append
                (
                const T & item
                );

            void Append
                (
                const T * array,
                size_t no
                );

            void Append
                (
                const SList<T,Limit> & slst
                );

            // remove all items from the list
            void Erase();

            // get current item
            T Get();

            // TRUE if current item is last item
            Boolean AtTail();

            // set current item to head of list
            void ToHead();

            // move to next item in list
            Boolean ToNext();

            // interrogate list
            size_t  GetCount();
            size_t  GetLimit();
            Boolean IsCircular();

        protected:
            size_t Count;      // # of items in list
            size_t Work;       // currently-selected element
            T Data[Limit];     // elements in list

            Boolean Circular; // is this a circular list?

            // internal utility functions
            void DeepCopy
                (
                const SList<T,Limit> & slst
                );
        };

#endif
 
/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.1 $

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */

